Index: /branches/SHM-dev/source/App/TAppDecoder/TAppDecTop.h
===================================================================
--- /branches/SHM-dev/source/App/TAppDecoder/TAppDecTop.h	(revision 1459)
+++ /branches/SHM-dev/source/App/TAppDecoder/TAppDecTop.h	(revision 1460)
@@ -66,23 +66,22 @@
   TDecTop*                        m_apcTDecTop[MAX_NUM_LAYER_IDS];                     ///< decoder point class 
   TVideoIOYuv*                    m_apcTVideoIOYuvReconFile[MAX_NUM_LAYER_IDS];        ///< reconstruction YUV class
+#if CONFORMANCE_BITSTREAM_MODE
+  TVideoIOYuv                     m_confReconFile[63];        ///< decode YUV files
+#endif 
+  // for output control
+  Int                             m_aiPOCLastDisplay [MAX_LAYERS]; ///< last POC in display order
 #else
   TDecTop                         m_cTDecTop;                     ///< decoder class
   TVideoIOYuv                     m_cTVideoIOYuvReconFile;        ///< reconstruction YUV class
+
+  // for output control
+  Int                             m_iPOCLastDisplay;              ///< last POC in display order
 #endif
-  
-  // for output control  
+
   std::ofstream                   m_seiMessageFileStream;         ///< Used for outputing SEI messages.
 
-#if SVC_EXTENSION
-#if CONFORMANCE_BITSTREAM_MODE
-  TVideoIOYuv                     m_confReconFile[63];        ///< decode YUV files
-#endif 
-  Int                             m_aiPOCLastDisplay [MAX_LAYERS]; ///< last POC in display order
-#else
-  Int                             m_iPOCLastDisplay;              ///< last POC in display order
-#endif
 #if Q0074_COLOUR_REMAPPING_SEI
-  std::vector<SEIColourRemappingInfo> storeCriSEI; //Persistent Colour Remapping Information SEI
-  SEIColourRemappingInfo *seiColourRemappingInfoPrevious;
+  SEIColourRemappingInfo*         m_pcSeiColourRemappingInfoPrevious;
+  TComPicYuv*                     m_pcPicYuvColourRemapped;       ///< Colour Remapped picture
 #endif
 
@@ -117,9 +116,5 @@
   Void  xDestroyDecLib    (); ///< destroy internal classes
   Void  xInitDecLib       (); ///< initialize decoder class
-  
-#if Q0074_COLOUR_REMAPPING_SEI
-  Void  xInitColourRemappingLut( const BitDepths &bitDepths, std::vector<Int>(&preLut)[3], std::vector<Int>(&postLut)[3], const SEIColourRemappingInfo* const pCriSEI );
-  Void  xApplyColourRemapping( const TComSPS *sps, TComPicYuv& pic, const SEIColourRemappingInfo* pCriSEI, UInt layerId = 0 );
-#endif
+
 #if SVC_EXTENSION
   Void  xWriteOutput      ( TComList<TComPic*>* pcListPic, UInt layerId, UInt tId ); ///< write YUV to file
@@ -130,4 +125,10 @@
 #endif
   Bool  isNaluWithinTargetDecLayerIdSet ( InputNALUnit* nalu ); ///< check whether given Nalu is within targetDecLayerIdSet
+
+#if Q0074_COLOUR_REMAPPING_SEI
+private:
+  Void applyColourRemapping(const TComPicYuv& pic, SEIColourRemappingInfo& pCriSEI, const TComSPS &activeSPS);
+  Void xOutputColourRemapPic(TComPic* pcPic, const TComSPS* activeSPS);
+#endif
 #if ALIGNED_BUMPING
   Void checkOutputBeforeDecoding(Int layerIdx);
Index: /branches/SHM-dev/source/App/TAppEncoder/TAppEncCfg.cpp
===================================================================
--- /branches/SHM-dev/source/App/TAppEncoder/TAppEncCfg.cpp	(revision 1459)
+++ /branches/SHM-dev/source/App/TAppEncoder/TAppEncCfg.cpp	(revision 1460)
@@ -774,5 +774,5 @@
   Int*    cfg_maxTidIlRefPicsPlus1[MAX_LAYERS]; 
 #if Q0074_COLOUR_REMAPPING_SEI
-  string* cfg_colourRemapSEIFileName[MAX_LAYERS];
+  string* cfg_colourRemapSEIFileRoot[MAX_LAYERS];
 #endif
   Bool*   cfg_entropyCodingSyncEnabledFlag[MAX_LAYERS];
@@ -793,5 +793,5 @@
     cfg_fQP[layer]          = &m_apcLayerCfg[layer]->m_fQP;
 #if Q0074_COLOUR_REMAPPING_SEI
-    cfg_colourRemapSEIFileName[layer] = &m_apcLayerCfg[layer]->m_colourRemapSEIFileName;
+    cfg_colourRemapSEIFileRoot[layer] = &m_apcLayerCfg[layer]->m_colourRemapSEIFileRoot;
 #endif
     cfg_repFormatIdx[layer]         = &m_apcLayerCfg[layer]->m_repFormatIdx;
@@ -1073,5 +1073,5 @@
   ("PhaseVerChroma%d",                              cfg_phaseVerChromaPtr,            string(""), m_numLayers, "chroma shift in the vertical   direction used in resampling proces")
 #if Q0074_COLOUR_REMAPPING_SEI
-  ("SEIColourRemappingInfoFileRoot%d",              cfg_colourRemapSEIFileName,       string(""), m_numLayers, "Colour Remapping Information SEI parameters file name for layer %d")
+  ("SEIColourRemappingInfoFileRoot%d,-cri",         cfg_colourRemapSEIFileRoot,       string(""), m_numLayers, "Colour Remapping Information SEI parameters root file name (wo num ext)")
 #endif
   ("InputBitDepth%d",                                cfg_InputBitDepth[CHANNEL_TYPE_LUMA],     8, m_numLayers, "Bit-depth of input file for layer %d")
@@ -1141,8 +1141,5 @@
 #if !SVC_EXTENSION
   ("FrameRate,-fr",                                   m_iFrameRate,                                         0, "Frame rate")
-#if Q0074_COLOUR_REMAPPING_SEI
-  ("SEIColourRemappingInfoFileRoot",                  m_colourRemapSEIFileName,                    string(""), "Colour Remapping Information SEI parameters file name")
-#endif
-#endif //SVC_EXTENSION
+#endif
   ("FrameSkip,-fs",                                   m_FrameSkip,                                         0u, "Number of frames to skip at start of input YUV")
   ("FramesToBeEncoded,f",                             m_framesToBeEncoded,                                  0, "Number of frames to be encoded (default=all)")
@@ -1462,4 +1459,9 @@
   ("Log2MaxMvLengthHorizontal",                       m_log2MaxMvLengthHorizontal,                         15, "Indicate the maximum absolute value of a decoded horizontal MV component in quarter-pel luma units")
   ("Log2MaxMvLengthVertical",                         m_log2MaxMvLengthVertical,                           15, "Indicate the maximum absolute value of a decoded vertical MV component in quarter-pel luma units")
+#if !SVC_EXTENSION
+#if Q0074_COLOUR_REMAPPING_SEI
+  ("SEIColourRemappingInfoFileRoot,-cri",             m_colourRemapSEIFileRoot,                    string(""), "Colour Remapping Information SEI parameters root file name (wo num ext)")
+#endif
+#endif
   ("SEIRecoveryPoint",                                m_recoveryPointSEIEnabled,                        false, "Control generation of recovery point SEI messages")
   ("SEIBufferingPeriod",                              m_bufferingPeriodSEIEnabled,                      false, "Control generation of buffering period SEI messages")
@@ -1566,5 +1568,5 @@
   ("SEIMasteringDisplayPrimaries",                    cfg_DisplayPrimariesCode,       cfg_DisplayPrimariesCode, "Mastering display primaries for all three colour planes in CIE xy coordinates in increments of 1/50000 (results in the ranges 0 to 50000 inclusive)")
   ("SEIMasteringDisplayWhitePoint",                   cfg_DisplayWhitePointCode,     cfg_DisplayWhitePointCode, "Mastering display white point CIE xy coordinates in normalised increments of 1/50000 (e.g. 0.333 = 16667)")
- 
+
 #if LAYERS_NOT_PRESENT_SEI
   ("SEILayersNotPresent",                             m_layersNotPresentSEIEnabled,             0, "Control generation of layers not present SEI message")
Index: /branches/SHM-dev/source/App/TAppEncoder/TAppEncCfg.h
===================================================================
--- /branches/SHM-dev/source/App/TAppEncoder/TAppEncCfg.h	(revision 1459)
+++ /branches/SHM-dev/source/App/TAppEncoder/TAppEncCfg.h	(revision 1460)
@@ -457,4 +457,9 @@
   Int       m_log2MaxMvLengthHorizontal;                      ///< Indicate the maximum absolute value of a decoded horizontal MV component in quarter-pel luma units
   Int       m_log2MaxMvLengthVertical;                        ///< Indicate the maximum absolute value of a decoded vertical MV component in quarter-pel luma units
+#if !SVC_EXTENSION
+#if Q0074_COLOUR_REMAPPING_SEI
+  std::string m_colourRemapSEIFileRoot;
+#endif
+#endif
 
   std::string m_summaryOutFilename;                           ///< filename to use for producing summary output file.
@@ -486,9 +491,5 @@
   Bool      m_elRapSliceBEnabled;
 #endif
-#if Q0074_COLOUR_REMAPPING_SEI
-#if !SVC_EXTENSION
-  string    m_colourRemapSEIFileName;
-#endif
-#endif
+
   // internal member functions
 #if SVC_EXTENSION
Index: /branches/SHM-dev/source/App/TAppEncoder/TAppEncLayerCfg.cpp
===================================================================
--- /branches/SHM-dev/source/App/TAppEncoder/TAppEncLayerCfg.cpp	(revision 1459)
+++ /branches/SHM-dev/source/App/TAppEncoder/TAppEncLayerCfg.cpp	(revision 1460)
@@ -31,10 +31,4 @@
 , m_repFormatIdx(-1)
 {
-#if Q0074_COLOUR_REMAPPING_SEI
-  memset( m_colourRemapSEIPreLutCodedValue,   0, sizeof(m_colourRemapSEIPreLutCodedValue) );
-  memset( m_colourRemapSEIPreLutTargetValue,  0, sizeof(m_colourRemapSEIPreLutTargetValue) );
-  memset( m_colourRemapSEIPostLutCodedValue,  0, sizeof(m_colourRemapSEIPostLutCodedValue) );
-  memset( m_colourRemapSEIPostLutTargetValue, 0, sizeof(m_colourRemapSEIPostLutTargetValue) );
-#endif
   m_confWinLeft = m_confWinRight = m_confWinTop = m_confWinBottom = 0;
   m_aiPad[1] = m_aiPad[0] = 0;
@@ -64,25 +58,4 @@
     delete[] m_aidQP;
   }
-#if Q0074_COLOUR_REMAPPING_SEI
-  for( Int c=0 ; c<3 ; c++)
-  {
-    if ( m_colourRemapSEIPreLutCodedValue[c] )
-    {
-      delete[] m_colourRemapSEIPreLutCodedValue[c];
-    }
-    if ( m_colourRemapSEIPreLutTargetValue[c] )
-    {
-      delete[] m_colourRemapSEIPreLutTargetValue[c];
-    }
-    if ( m_colourRemapSEIPostLutCodedValue[c] )
-    {
-      delete[] m_colourRemapSEIPostLutCodedValue[c];
-    }
-    if ( m_colourRemapSEIPostLutTargetValue[c] )
-    {
-      delete[] m_colourRemapSEIPostLutTargetValue[c];
-    }
-  }
-#endif
 }
 
Index: /branches/SHM-dev/source/App/TAppEncoder/TAppEncLayerCfg.h
===================================================================
--- /branches/SHM-dev/source/App/TAppEncoder/TAppEncLayerCfg.h	(revision 1459)
+++ /branches/SHM-dev/source/App/TAppEncoder/TAppEncLayerCfg.h	(revision 1460)
@@ -135,24 +135,5 @@
   Int       m_repFormatIdx;
 #if Q0074_COLOUR_REMAPPING_SEI
-  string    m_colourRemapSEIFileName;                         ///< Colour Remapping Information SEI message parameters file
-  Int       m_colourRemapSEIId;
-  Bool      m_colourRemapSEICancelFlag;
-  Bool      m_colourRemapSEIPersistenceFlag;
-  Bool      m_colourRemapSEIVideoSignalInfoPresentFlag;
-  Bool      m_colourRemapSEIFullRangeFlag;
-  Int       m_colourRemapSEIPrimaries;
-  Int       m_colourRemapSEITransferFunction;
-  Int       m_colourRemapSEIMatrixCoefficients;
-  Int       m_colourRemapSEIInputBitDepth;
-  Int       m_colourRemapSEIBitDepth;
-  Int       m_colourRemapSEIPreLutNumValMinus1[3];
-  Int*      m_colourRemapSEIPreLutCodedValue[3];
-  Int*      m_colourRemapSEIPreLutTargetValue[3];
-  Bool      m_colourRemapSEIMatrixPresentFlag;
-  Int       m_colourRemapSEILog2MatrixDenom;
-  Int       m_colourRemapSEICoeffs[3][3];
-  Int       m_colourRemapSEIPostLutNumValMinus1[3];
-  Int*      m_colourRemapSEIPostLutCodedValue[3];
-  Int*      m_colourRemapSEIPostLutTargetValue[3];
+  string    m_colourRemapSEIFileRoot;
 #endif
 
Index: /branches/SHM-dev/source/App/TAppEncoder/TAppEncTop.cpp
===================================================================
--- /branches/SHM-dev/source/App/TAppEncoder/TAppEncTop.cpp	(revision 1459)
+++ /branches/SHM-dev/source/App/TAppEncoder/TAppEncTop.cpp	(revision 1460)
@@ -505,9 +505,11 @@
     Bool&          m_bUseSAO                                    = m_apcLayerCfg[layer]->m_bUseSAO;
 
-    string&        m_colourRemapSEIFileName                     = m_apcLayerCfg[layer]->m_colourRemapSEIFileName;
-
     GOPEntry*      m_GOPList                                    = m_apcLayerCfg[layer]->m_GOPList;
     Int&           m_extraRPSs                                  = m_apcLayerCfg[layer]->m_extraRPSs;
     Int&           m_maxTempLayer                               = m_apcLayerCfg[layer]->m_maxTempLayer;
+
+#if Q0074_COLOUR_REMAPPING_SEI
+    string&        m_colourRemapSEIFileRoot                     = m_apcLayerCfg[layer]->m_colourRemapSEIFileRoot;
+#endif
 #endif
 
@@ -542,5 +544,4 @@
   m_cTEncTop.setGopList                                           ( m_GOPList );
   m_cTEncTop.setExtraRPSs                                         ( m_extraRPSs );
-
   for(Int i = 0; i < MAX_TLAYER; i++)
   {
@@ -765,4 +766,7 @@
   m_cTEncTop.setKneeSEIInputKneePoint                             ( m_kneeSEIInputKneePoint );
   m_cTEncTop.setKneeSEIOutputKneePoint                            ( m_kneeSEIOutputKneePoint );
+#if Q0074_COLOUR_REMAPPING_SEI
+  m_cTEncTop.setColourRemapInfoSEIFileRoot                        ( m_colourRemapSEIFileRoot );
+#endif
   m_cTEncTop.setMasteringDisplaySEI                               ( m_masteringDisplay );
 
@@ -842,7 +846,4 @@
   m_cTEncTop.setSummaryVerboseness                                ( m_summaryVerboseness );
 
-#if Q0074_COLOUR_REMAPPING_SEI
-  m_cTEncTop.xSetCRISEIFileRoot                                   ( m_colourRemapSEIFileName );
-#endif
 #if LAYERS_NOT_PRESENT_SEI
   m_cTEncTop.setLayersNotPresentSEIEnabled                        ( m_layersNotPresentSEIEnabled );
Index: /branches/SHM-dev/source/Lib/TLibCommon/SEI.cpp
===================================================================
--- /branches/SHM-dev/source/Lib/TLibCommon/SEI.cpp	(revision 1459)
+++ /branches/SHM-dev/source/Lib/TLibCommon/SEI.cpp	(revision 1460)
@@ -150,5 +150,5 @@
     case SEI::CHROMA_RESAMPLING_FILTER_HINT:        return "Chroma sampling filter hint";
 #if Q0074_COLOUR_REMAPPING_SEI
-    case SEI::COLOUR_REMAPPING_INFO:                return "Colour Remapping Information";
+    case SEI::COLOUR_REMAPPING_INFO:                return "Colour remapping info";
 #endif
 #if SVC_EXTENSION
@@ -196,49 +196,2 @@
 }
 #endif
-
-#if Q0074_COLOUR_REMAPPING_SEI
-Void  SEIColourRemappingInfo::copyFrom( SEIColourRemappingInfo const * SeiCriInput)
-{
-  m_colourRemapId                         = SeiCriInput->m_colourRemapId;
-  m_colourRemapCancelFlag                 = SeiCriInput->m_colourRemapCancelFlag;
-  m_colourRemapPersistenceFlag            = SeiCriInput->m_colourRemapPersistenceFlag;
-  m_colourRemapVideoSignalInfoPresentFlag = SeiCriInput->m_colourRemapVideoSignalInfoPresentFlag;
-  m_colourRemapFullRangeFlag              = SeiCriInput->m_colourRemapFullRangeFlag;
-  m_colourRemapPrimaries                  = SeiCriInput->m_colourRemapPrimaries;
-  m_colourRemapTransferFunction           = SeiCriInput->m_colourRemapTransferFunction;
-  m_colourRemapMatrixCoefficients         = SeiCriInput->m_colourRemapMatrixCoefficients;
-  m_colourRemapInputBitDepth              = SeiCriInput->m_colourRemapInputBitDepth;
-  m_colourRemapBitDepth                   = SeiCriInput->m_colourRemapBitDepth;
-
-  for( Int c=0 ; c<3 ; c++ )
-  {
-    m_preLutNumValMinus1[c] = SeiCriInput->m_preLutNumValMinus1[c];
-    m_preLutCodedValue[c].resize(m_preLutNumValMinus1[c]+1);
-    m_preLutTargetValue[c].resize(m_preLutNumValMinus1[c]+1);
-    for ( Int i=0 ; i <= SeiCriInput->m_preLutNumValMinus1[c] ; i++ )
-    {
-        m_preLutCodedValue[c][i]   = SeiCriInput->m_preLutCodedValue[c][i];
-        m_preLutTargetValue[c][i]  = SeiCriInput->m_preLutTargetValue[c][i];
-    } 
-  }
-    
-  m_colourRemapMatrixPresentFlag  = SeiCriInput->m_colourRemapMatrixPresentFlag;
-  m_log2MatrixDenom               = SeiCriInput->m_log2MatrixDenom;
-
-  for ( Int c=0 ; c<3 ; c++ )
-    for ( Int i=0 ; i<3 ; i++ )
-      m_colourRemapCoeffs[c][i] = SeiCriInput->m_colourRemapCoeffs[c][i];
-
-  for( Int c=0 ; c<3 ; c++ )
-  {
-    m_postLutNumValMinus1[c] = SeiCriInput->m_postLutNumValMinus1[c];
-    m_postLutCodedValue[c].resize(m_postLutNumValMinus1[c]+1);
-    m_postLutTargetValue[c].resize(m_postLutNumValMinus1[c]+1);
-    for ( Int i=0 ; i <= m_postLutNumValMinus1[c] ; i++ )
-    {
-        m_postLutCodedValue[c][i]  = SeiCriInput->m_postLutCodedValue[c][i];
-        m_postLutTargetValue[c][i] = SeiCriInput->m_postLutTargetValue[c][i];
-    } 
-  }
-}
-#endif
Index: /branches/SHM-dev/source/Lib/TLibCommon/SEI.h
===================================================================
--- /branches/SHM-dev/source/Lib/TLibCommon/SEI.h	(revision 1459)
+++ /branches/SHM-dev/source/Lib/TLibCommon/SEI.h	(revision 1460)
@@ -459,4 +459,48 @@
 };
 
+#if Q0074_COLOUR_REMAPPING_SEI
+class SEIColourRemappingInfo : public SEI
+{
+public:
+
+  struct CRIlut
+  {
+    Int codedValue;
+    Int targetValue;
+    bool operator < (const CRIlut& a) const
+    {
+      return codedValue < a.codedValue;
+    }
+  };
+
+  PayloadType payloadType() const { return COLOUR_REMAPPING_INFO; }
+  SEIColourRemappingInfo() {}
+  ~SEIColourRemappingInfo() {}
+
+  Void copyFrom( const SEIColourRemappingInfo &seiCriInput)
+  {
+    (*this) = seiCriInput;
+  }
+
+  UInt                m_colourRemapId;
+  Bool                m_colourRemapCancelFlag;
+  Bool                m_colourRemapPersistenceFlag;
+  Bool                m_colourRemapVideoSignalInfoPresentFlag;
+  Bool                m_colourRemapFullRangeFlag;
+  Int                 m_colourRemapPrimaries;
+  Int                 m_colourRemapTransferFunction;
+  Int                 m_colourRemapMatrixCoefficients;
+  Int                 m_colourRemapInputBitDepth;
+  Int                 m_colourRemapBitDepth;
+  Int                 m_preLutNumValMinus1[3];
+  std::vector<CRIlut> m_preLut[3];
+  Bool                m_colourRemapMatrixPresentFlag;
+  Int                 m_log2MatrixDenom;
+  Int                 m_colourRemapCoeffs[3][3];
+  Int                 m_postLutNumValMinus1[3];
+  std::vector<CRIlut> m_postLut[3];
+};
+#endif
+
 class SEIChromaResamplingFilterHint : public SEI
 {
@@ -673,60 +717,4 @@
 #endif
 
-#if Q0074_COLOUR_REMAPPING_SEI
-struct TComSEIColourRemappingInfo
-{
-  std::string             m_colourRemapSEIFile;
-  Int                     m_colourRemapSEIId;
-  Bool                    m_colourRemapSEICancelFlag;
-  Bool                    m_colourRemapSEIPersistenceFlag;
-  Bool                    m_colourRemapSEIVideoSignalInfoPresentFlag;
-  Bool                    m_colourRemapSEIFullRangeFlag;
-  Int                     m_colourRemapSEIPrimaries;
-  Int                     m_colourRemapSEITransferFunction;
-  Int                     m_colourRemapSEIMatrixCoefficients;
-  Int                     m_colourRemapSEIInputBitDepth;
-  Int                     m_colourRemapSEIBitDepth;
-  Int                     m_colourRemapSEIPreLutNumValMinus1[3];
-  Int*                    m_colourRemapSEIPreLutCodedValue[3];
-  Int*                    m_colourRemapSEIPreLutTargetValue[3];
-  Bool                    m_colourRemapSEIMatrixPresentFlag;
-  Int                     m_colourRemapSEILog2MatrixDenom;
-  Int                     m_colourRemapSEICoeffs[3][3];
-  Int                     m_colourRemapSEIPostLutNumValMinus1[3];
-  Int*                    m_colourRemapSEIPostLutCodedValue[3];
-  Int*                    m_colourRemapSEIPostLutTargetValue[3];
-};
-
-class SEIColourRemappingInfo : public SEI
-{
-public:
-  PayloadType payloadType() const { return COLOUR_REMAPPING_INFO; }
-  SEIColourRemappingInfo() {}
-  ~SEIColourRemappingInfo() {}
-
-  Void  copyFrom( SEIColourRemappingInfo const * SeiCriInput);
- 
-  Int   m_colourRemapId;
-  Bool  m_colourRemapCancelFlag;
-  Bool  m_colourRemapPersistenceFlag;
-  Bool  m_colourRemapVideoSignalInfoPresentFlag;
-  Bool  m_colourRemapFullRangeFlag;
-  Int   m_colourRemapPrimaries;
-  Int   m_colourRemapTransferFunction;
-  Int   m_colourRemapMatrixCoefficients;
-  Int   m_colourRemapInputBitDepth;
-  Int   m_colourRemapBitDepth;
-  Int   m_preLutNumValMinus1[3];
-  std::vector<Int> m_preLutCodedValue[3];
-  std::vector<Int> m_preLutTargetValue[3];
-  Bool  m_colourRemapMatrixPresentFlag;
-  Int   m_log2MatrixDenom;
-  Int   m_colourRemapCoeffs[3][3];
-  Int   m_postLutNumValMinus1[3];
-  std::vector<Int> m_postLutCodedValue[3];
-  std::vector<Int> m_postLutTargetValue[3];
-};
-#endif
-
 #if N0383_IL_CONSTRAINED_TILE_SETS_SEI
 class SEIInterLayerConstrainedTileSets : public SEI
Index: /branches/SHM-dev/source/Lib/TLibCommon/TComPicYuv.cpp
===================================================================
--- /branches/SHM-dev/source/Lib/TLibCommon/TComPicYuv.cpp	(revision 1459)
+++ /branches/SHM-dev/source/Lib/TLibCommon/TComPicYuv.cpp	(revision 1460)
@@ -296,13 +296,20 @@
 
 // NOTE: This function is never called, but may be useful for developers.
-Void TComPicYuv::dump (const std::string &fileName, const BitDepths &bitDepths, Bool bAdd) const
-{
-  FILE* pFile = fopen (fileName.c_str(), bAdd?"ab":"wb");
+Void TComPicYuv::dump (const std::string &fileName, const BitDepths &bitDepths, const Bool bAppend, const Bool bForceTo8Bit) const
+{
+  FILE *pFile = fopen (fileName.c_str(), bAppend?"ab":"wb");
+
+  Bool is16bit=false;
+  for(Int comp = 0; comp < getNumberValidComponents() && !bForceTo8Bit; comp++)
+  {
+    if (bitDepths.recon[toChannelType(ComponentID(comp))]>8)
+    {
+      is16bit=true;
+    }
+  }
 
   for(Int comp = 0; comp < getNumberValidComponents(); comp++)
   {
     const ComponentID  compId = ComponentID(comp);
-    const Int          shift  = bitDepths.recon[toChannelType(compId)] - 8;
-    const Int          offset = (shift>0)?(1<<(shift-1)):0;
     const Pel         *pi     = getAddr(compId);
     const Int          stride = getStride(compId);
@@ -310,51 +317,34 @@
     const Int          width  = getWidth(compId);
 
-    for (Int y = 0; y < height; y++ )
-    {
-      for (Int x = 0; x < width; x++ )
-      {
-        UChar uc = (UChar)Clip3<Pel>(0, 255, (pi[x]+offset)>>shift);
-        fwrite( &uc, sizeof(UChar), 1, pFile );
-      }
-      pi += stride;
-    }
-  }
-
-  fclose(pFile);
-}
-
-Void TComPicYuv::dump( const std::string &fileName, const Bool bAdd, const Int bitDepth )
-{
-  FILE* pFile = fopen (fileName.c_str(), bAdd?"ab":"wb");
-
-  if( bitDepth == 8 )
-  {
-    dump( fileName, bitDepth, bAdd );
-    return;
-  }
-
-  for(Int chan = 0; chan < getNumberValidComponents(); chan++)
-  {
-    const ComponentID  ch     = ComponentID(chan);
-    const Pel         *pi     = getAddr(ch);
-    const Int          stride = getStride(ch);
-    const Int          height = getHeight(ch);
-    const Int          width  = getWidth(ch);
-
-    for (Int y = 0; y < height; y++ )
-    {
-      for (Int x = 0; x < width; x++ )
-      {
-        Pel pix = pi[x];
-
-        UChar uc = pix & 0xff;      
-        fwrite( &uc, sizeof(UChar), 1, pFile );
-        uc = (pix >> 8) & 0xff;      
-        fwrite( &uc, sizeof(UChar), 1, pFile );
-      }
-      pi += stride;
-    }
-  }
-  
+    if (is16bit)
+    {
+      for (Int y = 0; y < height; y++ )
+      {
+        for (Int x = 0; x < width; x++ )
+        {
+          UChar uc = (UChar)((pi[x]>>0) & 0xff);
+          fwrite( &uc, sizeof(UChar), 1, pFile );
+          uc = (UChar)((pi[x]>>8) & 0xff);
+          fwrite( &uc, sizeof(UChar), 1, pFile );
+        }
+        pi += stride;
+      }
+    }
+    else
+    {
+      const Int shift  = bitDepths.recon[toChannelType(compId)] - 8;
+      const Int offset = (shift>0)?(1<<(shift-1)):0;
+      for (Int y = 0; y < height; y++ )
+      {
+        for (Int x = 0; x < width; x++ )
+        {
+          UChar uc = (UChar)Clip3<Pel>(0, 255, (pi[x]+offset)>>shift);
+          fwrite( &uc, sizeof(UChar), 1, pFile );
+        }
+        pi += stride;
+      }
+    }
+  }
+
   fclose(pFile);
 }
Index: /branches/SHM-dev/source/Lib/TLibCommon/TComPicYuv.h
===================================================================
--- /branches/SHM-dev/source/Lib/TLibCommon/TComPicYuv.h	(revision 1459)
+++ /branches/SHM-dev/source/Lib/TLibCommon/TComPicYuv.h	(revision 1460)
@@ -180,5 +180,5 @@
 
   //  Dump picture
-  Void          dump              (const std::string &fileName, const BitDepths &bitDepths, Bool bAdd = false) const ;
+  Void          dump              (const std::string &fileName, const BitDepths &bitDepths, const Bool bAppend=false, const Bool bForceTo8Bit=false) const ;
 
   // Set border extension flag
@@ -196,6 +196,4 @@
 #endif
 
-  Void          dump( const std::string &fileName, const Bool bAdd, const Int bitDepth );
-
 };// END CLASS DEFINITION TComPicYuv
 
Index: /branches/SHM-dev/source/Lib/TLibCommon/TypeDef.h
===================================================================
--- /branches/SHM-dev/source/Lib/TLibCommon/TypeDef.h	(revision 1459)
+++ /branches/SHM-dev/source/Lib/TLibCommon/TypeDef.h	(revision 1460)
@@ -127,5 +127,4 @@
 
 #endif // SVC_EXTENSION
-#define Q0074_COLOUR_REMAPPING_SEI       1      ///< JCTVC-Q0074, JCTVC-R0344: SEI Colour Remapping Information
 
 //! \ingroup TLibCommon
@@ -166,4 +165,5 @@
 #define T0196_SELECTIVE_RDOQ                              1 ///< selective RDOQ
 #define U0040_MODIFIED_WEIGHTEDPREDICTION_WITH_BIPRED_AND_CLIPPING 1
+#define Q0074_COLOUR_REMAPPING_SEI                        1      ///< JCTVC-Q0074, JCTVC-R0344: SEI Colour Remapping Information
 
 // ====================================================================================================================
@@ -377,4 +377,21 @@
   NUMBER_INPUT_COLOUR_SPACE_CONVERSIONS = 4
 };
+
+#if Q0074_COLOUR_REMAPPING_SEI
+enum MATRIX_COEFFICIENTS // Table E.5 (Matrix coefficients)
+{
+  MATRIX_COEFFICIENTS_RGB                           = 0,
+  MATRIX_COEFFICIENTS_BT709                         = 1,
+  MATRIX_COEFFICIENTS_UNSPECIFIED                   = 2,
+  MATRIX_COEFFICIENTS_RESERVED_BY_ITUISOIEC         = 3,
+  MATRIX_COEFFICIENTS_USFCCT47                      = 4,
+  MATRIX_COEFFICIENTS_BT601_625                     = 5,
+  MATRIX_COEFFICIENTS_BT601_525                     = 6,
+  MATRIX_COEFFICIENTS_SMPTE240                      = 7,
+  MATRIX_COEFFICIENTS_YCGCO                         = 8,
+  MATRIX_COEFFICIENTS_BT2020_NON_CONSTANT_LUMINANCE = 9,
+  MATRIX_COEFFICIENTS_BT2020_CONSTANT_LUMINANCE     = 10,
+};
+#endif
 
 enum DeblockEdgeDir
